<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Simulator &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../_static/jquery.js?v=5d32c60e"></script>
        <script src="../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../_static/doctools.js?v=888ff710"></script>
        <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Agent Components" href="simulator/agent_components.html" />
    <link rel="prev" title="VehicleComponents" href="../user_guide/sim_user_guide/components/vehicle.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../index.html" class="icon icon-home">
            openPASS
              <img src="../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">Simulator</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html">Agent Components</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/coordinate_systems.html">Coordinate Systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/event_detector.html">EventDetector</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html">Mapping of OpenSCENARIO Actions</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/simulation.html">Simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/spawner_features.html">Spawner Features</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html">System Structure and Parameterization (SSP)</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/world_osi.html">World_OSI</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Simulator</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/advanced_topics/20_simulator_advanced.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="simulator">
<span id="simulator-advanced"></span><h1>Simulator<a class="headerlink" href="#simulator" title="Link to this heading"></a></h1>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="simulator/agent_components.html">Agent Components</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#action-longitudinaldriver">Action_LongitudinalDriver</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#action-secondarydriver">Action_SecondaryDriver</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#agentupdater">AgentUpdater</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#algorithm-lateral">Algorithm_Lateral</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#algorithm-longitudinal">Algorithm_Longitudinal</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#algorithmcar2xsender">AlgorithmCar2XSender</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#dynamics-collision">Dynamics_Collision</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#dynamics-scenario">Dynamics_Scenario</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#dynamics-regulardriving">Dynamics_RegularDriving</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#limiteraccelerationvehiclecomponents">LimiterAccelerationVehicleComponents</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#openscenarioactions">OpenScenarioActions</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#parameters-vehicle">Parameters_Vehicle</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#vehicle-model-related-parameters">Vehicle model related parameters</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#powertrain-related-parameters">Powertrain related parameters</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#steering-related-parameters">Steering related parameters</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#sensor-driver">Sensor_Driver</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#sensor-osi">Sensor_OSI</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#sensorgeometric2d">SensorGeometric2D</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#function">Function</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#cases">Cases</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#visual-obstruction">Visual Obstruction</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#sensorfusionosi">SensorFusionOSI</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#signalprioritizer">SignalPrioritizer</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/agent_components.html#componentcontroller">ComponentController</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#overview">Overview</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#state-handling-inside-vehicle-component">State handling inside Vehicle Component</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/agent_components.html#used-signals">Used signals</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="simulator/coordinate_systems.html">Coordinate Systems</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/coordinate_systems.html#world-coordinate-system">World Coordinate System</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/coordinate_systems.html#road-coordinate-system">Road Coordinate System</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/coordinate_systems.html#agent-coordinate-system">Agent Coordinate System</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="simulator/coordinate_systems.html#sensor-coordinate-system">Sensor Coordinate System</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/coordinate_systems.html#conversions-between-sensordata-coordinate-systems">Conversions between SensorData coordinate systems</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="simulator/event_detector.html">EventDetector</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/event_detector.html#collisiondetector">CollisionDetector</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="simulator/scenario_actions.html">Mapping of OpenSCENARIO Actions</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#acquirepositionaction">AcquirePositionAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#assignrouteaction">AssignRouteAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#customcommandaction">CustomCommandAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#followtrajectoryaction">FollowTrajectoryAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#lanechangeaction">LaneChangeAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#lightstateaction">LightStateAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#speedaction">SpeedAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#teleportaction">TeleportAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#trafficsignalaction">TrafficSignalAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#trafficsignalstateaction">TrafficSignalStateAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#trafficsinkaction">TrafficSinkAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#visibilityaction">VisibilityAction</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/scenario_actions.html#id1">LightStateAction</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="simulator/simulation.html">Simulation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/simulation.html#command-line-arguments">Command Line Arguments</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/simulation.html#scheduler">Scheduler</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/simulation.html#executing-phases">Executing phases</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/simulation.html#task-type-description">Task type description</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/simulation.html#task-priorities">Task priorities</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="simulator/spawner_features.html">Spawner Features</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/spawner_features.html#prerunspawner">PreRunSpawner</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/spawner_features.html#spawning-on-roads-lanes-and-ranges">Spawning on roads, lanes and ranges</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/spawner_features.html#traffic-parameters">Traffic parameters</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/spawner_features.html#stochastics">Stochastics</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="simulator/spawner_features.html#runtimespawner">RuntimeSpawner</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/spawner_features.html#id2">Spawning on roads, lanes and ranges</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/spawner_features.html#id8">Traffic parameters</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/spawner_features.html#id11">Stochastics</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html">System Structure and Parameterization (SSP)</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#inputs-ssp-structure">Inputs / SSP Structure</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#system-structure-package-ssp">System Structure Package SSP</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#ssd-system-structure-definition">SSD - System Structure Definition</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#implementation">Implementation</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#parsing">Parsing</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#osi-connectors">OSI Connectors</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#object-structure">Object Structure</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#ssp-and-op">SSP and <strong>openPASS</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#limits">Limits</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#outputs">Outputs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#folderstructure">FolderStructure</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/system_structure_and_parameterization_%28SSP%29.html#writemessageparameters">WriteMessageParameters</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="simulator/world_osi.html">World_OSI</a><ul>
<li class="toctree-l2"><a class="reference internal" href="simulator/world_osi.html#sampling-of-world-geometries">Sampling of World Geometries</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/world_osi.html#localization">Localization</a><ul>
<li class="toctree-l3"><a class="reference internal" href="simulator/world_osi.html#basics">Basics</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulator/world_osi.html#localization-sequence">Localization Sequence</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="simulator/world_osi.html#traffic-signs-road-markings-and-trafficlights">Traffic Signs, Road Markings and TrafficLights</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/world_osi.html#lane-markings">Lane Markings</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulator/world_osi.html#getobstruction">GetObstruction</a></li>
</ul>
</li>
</ul>
</div>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../user_guide/sim_user_guide/components/vehicle.html" class="btn btn-neutral float-left" title="VehicleComponents" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="simulator/agent_components.html" class="btn btn-neutral float-right" title="Agent Components" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>